=== debian/changelog ===
ur-rtde (1.2.4-4) focal; urgency=medium

  [ Anders Prier Lindvig ]
  * Output of connection status is now optional through a verbose flag + updated README

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Thu, 16 Jul 2020 09:54:58 +0200

ur-rtde (1.2.4-3) focal; urgency=medium

  * initial focal Release 

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Wed, 15 Jul 2020 12:38:45 +0200

ur-rtde (1.2.4-2) focal; urgency=medium

  * initial debian Release 

 -- Kasper Høj Lorenzen <kalor@mmmi.sdu.dk>  Wed, 15 Jul 2020 12:38:45 +0200

ur-rtde (1.2.4-1) focal; urgency=medium

  [ Anders Prier Lindvig ]
  * Initial commit of UR RTDE project
  * Updated .gitignore to not include build folders
  * Retrieval of joint Q working
  * Rewrote ur_rtde to rely on boost only, implemented logic for receiving data
  * Add .gitlab-ci.yml
  * Update .gitlab-ci.yml
  * Add README.md
  * Implemented ability to send data to the controller + client
  * Implemented a dashboard client and initial RobotState class
  * Implemented a control interface and script client, 
    made RobotState thread-safe
  * Updated receive client to use new RobotState
  * Implemented speed and servo functions
  * Removed command queue, since not necessary
  * Reorganized project with src and include 
    and added doxy+sphinx built documentation
  * Added fix for building documentation with CI
  * Removed specific python version requirement
  * Add link to documentation in readme
  * Minor cleanup of RTDE class
  * Small update to how the doc. is shown
  * Implemented std and tool digital output functions
  * Added more files to the documentation + logo
  * Implemented a RTDE receive interface with documentation
  * Added some examples
  * Update README.md
  * The script is now compiled as a header, 
    to avoid file path issues and performance
  * If no vars are specified for RTDEReceiveInterface constructor 
    all vars are transmitted
  * Implement python bindings for RTDE Control and Receive Interface + doc

  [ Thomas Nicky Thulesen ]
  * Implemented target exports in CMake and tested on Windows.
  * Added include directories for the python libraries.
  * Added linking to thread library again.

  [ Anders Prier Lindvig ]
  * Made python bindings optional + added install target for python libraries
  * Python bindings off by default
  * Python bindings off by default for docs
  * Updated documentation of RTDEControlInterface
  * Added animation of force mode example

  [ Thomas Nicky Thulesen ]
  * Fixing compilation on Windows.
  * Fixed spelling mistake.
  * Fixed Windows exports.

  [ Anders Prier Lindvig ]
  * Added a servoj example
  * Changed send/receive protocol logic
  * Python 2.X is now supported + updated README
  * New servo impl. + added return status and timeout functionality
  * Added MoveL with path example and Updated servo example in doc
  * Added MoveJ with path example
  * Update README.md
  * Update README.md
  * Add LICENSE
  * Added installation to documentation and updated README
  * Impl. threaded speed movements, updated servo impl + documentation
  * Implemented ability to set payload and CoG
  * Implemented teach_mode and force mode gain and damping parameters
  * Implemented ability to set the speed slider
  * Implemented analog voltage and current functions 
    + RobotState are no longer inline
  * Update README.md
  * Added a CMake example to doc

  [ Thomas Nicky Thulesen ]
  * Made it possible for the user to customize the install directories.

  [ Anders Prier Lindvig ]
  * Increased execution timeout period
  * Added ur_rtde namespace for all classes 
    + made some function not avail on CB3
  * Fixed doc to work with namespace
  * Added Windows instructions to doc.
  * Changed highlighting for example in doc
  * Added missing return values to functions
  * Deleted the generated rtde_control_script header
  * Implemented ability to get robot status 
    + termination of running scripts before sending a new
  * Update README.md
  * Connection loss is now handled safely, 
    impl. status + reconnect, reported in #6
  * Added tip for testing to doc
  * New IO interface, add. connection safety and custom script functions
  * Made python bindings for the RTDE IO interface + doc

  [ Nathan Quinn ]
  * Added missing return statement in RTDERecieveInterface::reconnect()

  [ Anders Prier Lindvig ]
  * Implemented a servoL function as requested by Inigo
  * Fixed typo in RTDEIOInterface.
  * Make sure doc uses Python3 Interpreter
  * Revert to deprecated FindPythonInterp for doc
  * Update README.md
  * Added exception handling for connect() function
  * Global interpreter lock (GIL) is now released on function calls, 
    which allows for Python multithreading

  [ Kasper Høj Lorenzen ]
  * Removed warnings and updated install

  [ Anders Prier Lindvig ]
  * Update .gitlab-ci.yml
  * Impl. tool_contact, get_actual_joint_positions_history, 
    get_steptime, get_target_waypoint + new logic for control version
  * Reception of data now works again, missing ID message offset, 
    after a code cleanup

  [ Iñigo Iturrate San Juan ]
  * Added missing python bindings for new functions

  [ Anders Prier Lindvig ]
  * Updated tool_contact function, to use UR pose array in script

  [ Iñigo Iturrate San Juan ]
  * Added missing python bindings for teach mode.

  [ Anders Prier Lindvig ]
  * Allowed maximum values and added default arguments
    for velocity and acceleration
  * Added clearing of cmd register, before sending control script
  * pybind11 will now be found, if installed by pip
  * Updated documentation with macOS instructions + new pip install for pybind11
  * Update README.md
  * Make sure command register are cleared when initializing
  * Added CI pipeline for building and uploading to PyPi
  * Updated documentation and readme, with pip install option
  * Added building of wheel for Python 2.7

  [ scholle ]
  * add bidirectional communication in dashboard client

  [ Anders Prier Lindvig ]

